diff -Naur drupal-7.43/modules/simpletest/tests/upgrade/drupal-6.filled.database.php drupal-7.50/modules/simpletest/tests/upgrade/drupal-6.filled.database.php
--- drupal-7.43/modules/simpletest/tests/upgrade/drupal-6.filled.database.php	2016-02-24 20:26:52.000000000 +0100
+++ drupal-7.50/modules/simpletest/tests/upgrade/drupal-6.filled.database.php	2016-07-07 20:25:52.000000000 +0200
@@ -19919,7 +19919,7 @@
   'vid' => '1',
   'name' => 'vocabulary 1 (i=0)',
   'description' => 'description of vocabulary 1 (i=0)',
-  'help' => '',
+  'help' => 'help for vocabulary 1 (i=0)',
   'relations' => '1',
   'hierarchy' => '0',
   'multiple' => '0',
@@ -19932,7 +19932,7 @@
   'vid' => '2',
   'name' => 'vocabulary 2 (i=1)',
   'description' => 'description of vocabulary 2 (i=1)',
-  'help' => '',
+  'help' => 'help for vocabulary 2 (i=1)',
   'relations' => '1',
   'hierarchy' => '1',
   'multiple' => '1',
@@ -19945,7 +19945,7 @@
   'vid' => '3',
   'name' => 'vocabulary 3 (i=2)',
   'description' => 'description of vocabulary 3 (i=2)',
-  'help' => '',
+  'help' => 'help for vocabulary 3 (i=2)',
   'relations' => '1',
   'hierarchy' => '2',
   'multiple' => '0',
@@ -19958,7 +19958,7 @@
   'vid' => '4',
   'name' => 'vocabulary 4 (i=3)',
   'description' => 'description of vocabulary 4 (i=3)',
-  'help' => '',
+  'help' => 'help for vocabulary 4 (i=3)',
   'relations' => '1',
   'hierarchy' => '0',
   'multiple' => '1',
@@ -19971,7 +19971,7 @@
   'vid' => '5',
   'name' => 'vocabulary 5 (i=4)',
   'description' => 'description of vocabulary 5 (i=4)',
-  'help' => '',
+  'help' => 'help for vocabulary 5 (i=4)',
   'relations' => '1',
   'hierarchy' => '1',
   'multiple' => '0',
@@ -19984,7 +19984,7 @@
   'vid' => '6',
   'name' => 'vocabulary 6 (i=5)',
   'description' => 'description of vocabulary 6 (i=5)',
-  'help' => '',
+  'help' => 'help for vocabulary 6 (i=5)',
   'relations' => '1',
   'hierarchy' => '2',
   'multiple' => '1',
@@ -19997,7 +19997,7 @@
   'vid' => '7',
   'name' => 'vocabulary 7 (i=6)',
   'description' => 'description of vocabulary 7 (i=6)',
-  'help' => '',
+  'help' => 'help for vocabulary 7 (i=6)',
   'relations' => '1',
   'hierarchy' => '0',
   'multiple' => '0',
@@ -20010,7 +20010,7 @@
   'vid' => '8',
   'name' => 'vocabulary 8 (i=7)',
   'description' => 'description of vocabulary 8 (i=7)',
-  'help' => '',
+  'help' => 'help for vocabulary 8 (i=7)',
   'relations' => '1',
   'hierarchy' => '1',
   'multiple' => '1',
@@ -20023,7 +20023,7 @@
   'vid' => '9',
   'name' => 'vocabulary 9 (i=8)',
   'description' => 'description of vocabulary 9 (i=8)',
-  'help' => '',
+  'help' => 'help for vocabulary 9 (i=8)',
   'relations' => '1',
   'hierarchy' => '2',
   'multiple' => '0',
@@ -20036,7 +20036,7 @@
   'vid' => '10',
   'name' => 'vocabulary 10 (i=9)',
   'description' => 'description of vocabulary 10 (i=9)',
-  'help' => '',
+  'help' => 'help for vocabulary 10 (i=9)',
   'relations' => '1',
   'hierarchy' => '0',
   'multiple' => '1',
@@ -20049,7 +20049,7 @@
   'vid' => '11',
   'name' => 'vocabulary 11 (i=10)',
   'description' => 'description of vocabulary 11 (i=10)',
-  'help' => '',
+  'help' => 'help for vocabulary 11 (i=10)',
   'relations' => '1',
   'hierarchy' => '1',
   'multiple' => '0',
@@ -20062,7 +20062,7 @@
   'vid' => '12',
   'name' => 'vocabulary 12 (i=11)',
   'description' => 'description of vocabulary 12 (i=11)',
-  'help' => '',
+  'help' => 'help for vocabulary 12 (i=11)',
   'relations' => '1',
   'hierarchy' => '2',
   'multiple' => '1',
@@ -20075,7 +20075,7 @@
   'vid' => '13',
   'name' => 'vocabulary 13 (i=12)',
   'description' => 'description of vocabulary 13 (i=12)',
-  'help' => '',
+  'help' => 'help for vocabulary 13 (i=12)',
   'relations' => '1',
   'hierarchy' => '0',
   'multiple' => '0',
@@ -20088,7 +20088,7 @@
   'vid' => '14',
   'name' => 'vocabulary 14 (i=13)',
   'description' => 'description of vocabulary 14 (i=13)',
-  'help' => '',
+  'help' => 'help for vocabulary 14 (i=13)',
   'relations' => '1',
   'hierarchy' => '1',
   'multiple' => '1',
@@ -20101,7 +20101,7 @@
   'vid' => '15',
   'name' => 'vocabulary 15 (i=14)',
   'description' => 'description of vocabulary 15 (i=14)',
-  'help' => '',
+  'help' => 'help for vocabulary 15 (i=14)',
   'relations' => '1',
   'hierarchy' => '2',
   'multiple' => '0',
@@ -20114,7 +20114,7 @@
   'vid' => '16',
   'name' => 'vocabulary 16 (i=15)',
   'description' => 'description of vocabulary 16 (i=15)',
-  'help' => '',
+  'help' => 'help for vocabulary 16 (i=15)',
   'relations' => '1',
   'hierarchy' => '0',
   'multiple' => '1',
@@ -20127,7 +20127,7 @@
   'vid' => '17',
   'name' => 'vocabulary 17 (i=16)',
   'description' => 'description of vocabulary 17 (i=16)',
-  'help' => '',
+  'help' => 'help for vocabulary 17 (i=16)',
   'relations' => '1',
   'hierarchy' => '1',
   'multiple' => '0',
@@ -20140,7 +20140,7 @@
   'vid' => '18',
   'name' => 'vocabulary 18 (i=17)',
   'description' => 'description of vocabulary 18 (i=17)',
-  'help' => '',
+  'help' => 'help for vocabulary 18 (i=17)',
   'relations' => '1',
   'hierarchy' => '2',
   'multiple' => '1',
@@ -20153,7 +20153,7 @@
   'vid' => '19',
   'name' => 'vocabulary 19 (i=18)',
   'description' => 'description of vocabulary 19 (i=18)',
-  'help' => '',
+  'help' => 'help for vocabulary 19 (i=18)',
   'relations' => '1',
   'hierarchy' => '0',
   'multiple' => '0',
@@ -20166,7 +20166,7 @@
   'vid' => '20',
   'name' => 'vocabulary 20 (i=19)',
   'description' => 'description of vocabulary 20 (i=19)',
-  'help' => '',
+  'help' => 'help for vocabulary 20 (i=19)',
   'relations' => '1',
   'hierarchy' => '1',
   'multiple' => '1',
@@ -20179,7 +20179,7 @@
   'vid' => '21',
   'name' => 'vocabulary 21 (i=20)',
   'description' => 'description of vocabulary 21 (i=20)',
-  'help' => '',
+  'help' => 'help for vocabulary 21 (i=20)',
   'relations' => '1',
   'hierarchy' => '2',
   'multiple' => '0',
@@ -20192,7 +20192,7 @@
   'vid' => '22',
   'name' => 'vocabulary 22 (i=21)',
   'description' => 'description of vocabulary 22 (i=21)',
-  'help' => '',
+  'help' => 'help for vocabulary 22 (i=21)',
   'relations' => '1',
   'hierarchy' => '0',
   'multiple' => '1',
@@ -20205,7 +20205,7 @@
   'vid' => '23',
   'name' => 'vocabulary 23 (i=22)',
   'description' => 'description of vocabulary 23 (i=22)',
-  'help' => '',
+  'help' => 'help for vocabulary 23 (i=22)',
   'relations' => '1',
   'hierarchy' => '1',
   'multiple' => '0',
@@ -20218,7 +20218,7 @@
   'vid' => '24',
   'name' => 'vocabulary 24 (i=23)',
   'description' => 'description of vocabulary 24 (i=23)',
-  'help' => '',
+  'help' => 'help for vocabulary 24 (i=23)',
   'relations' => '1',
   'hierarchy' => '2',
   'multiple' => '1',
diff -Naur drupal-7.43/modules/simpletest/tests/upgrade/upgrade.taxonomy.test drupal-7.50/modules/simpletest/tests/upgrade/upgrade.taxonomy.test
--- drupal-7.43/modules/simpletest/tests/upgrade/upgrade.taxonomy.test	2016-02-24 20:26:52.000000000 +0100
+++ drupal-7.50/modules/simpletest/tests/upgrade/upgrade.taxonomy.test	2016-07-07 20:25:52.000000000 +0200
@@ -74,9 +74,10 @@
     $this->assertEqual($voc_keys, $inst_keys, 'Node type page has instances for every vocabulary.');
 
     // Ensure instance variables are getting through.
-    foreach ($instances as $instance) {
-      $this->assertTrue(isset($instance['required']), 'The required setting was preserved during the upgrade path.');
-      $this->assertTrue($instance['description'], 'The description was preserved during the upgrade path');
+    foreach (array_unique($instances) as $instance) {
+      $field_instance = field_info_instance('node', $instance, 'page');
+      $this->assertTrue(isset($field_instance['required']), 'The required setting was preserved during the upgrade path.');
+      $this->assertTrue($field_instance['description'], 'The description was preserved during the upgrade path');
     }
 
     // Node type 'story' was not explicitly in $vocabulary->nodes but
diff -Naur drupal-7.43/modules/simpletest/tests/url_alter_test.info drupal-7.50/modules/simpletest/tests/url_alter_test.info
--- drupal-7.43/modules/simpletest/tests/url_alter_test.info	2016-02-24 20:51:46.000000000 +0100
+++ drupal-7.50/modules/simpletest/tests/url_alter_test.info	2016-07-07 21:08:13.000000000 +0200
@@ -5,8 +5,8 @@
 version = VERSION
 hidden = TRUE
 
-; Information added by Drupal.org packaging script on 2016-02-24
-version = "7.43"
+; Information added by Drupal.org packaging script on 2016-07-07
+version = "7.50"
 project = "drupal"
-datestamp = "1456343506"
+datestamp = "1467918493"
 
diff -Naur drupal-7.43/modules/simpletest/tests/xmlrpc_test.info drupal-7.50/modules/simpletest/tests/xmlrpc_test.info
--- drupal-7.43/modules/simpletest/tests/xmlrpc_test.info	2016-02-24 20:51:46.000000000 +0100
+++ drupal-7.50/modules/simpletest/tests/xmlrpc_test.info	2016-07-07 21:08:13.000000000 +0200
@@ -5,8 +5,8 @@
 core = 7.x
 hidden = TRUE
 
-; Information added by Drupal.org packaging script on 2016-02-24
-version = "7.43"
+; Information added by Drupal.org packaging script on 2016-07-07
+version = "7.50"
 project = "drupal"
-datestamp = "1456343506"
+datestamp = "1467918493"
 
diff -Naur drupal-7.43/modules/statistics/statistics.info drupal-7.50/modules/statistics/statistics.info
--- drupal-7.43/modules/statistics/statistics.info	2016-02-24 20:51:46.000000000 +0100
+++ drupal-7.50/modules/statistics/statistics.info	2016-07-07 21:08:13.000000000 +0200
@@ -6,8 +6,8 @@
 files[] = statistics.test
 configure = admin/config/system/statistics
 
-; Information added by Drupal.org packaging script on 2016-02-24
-version = "7.43"
+; Information added by Drupal.org packaging script on 2016-07-07
+version = "7.50"
 project = "drupal"
-datestamp = "1456343506"
+datestamp = "1467918493"
 
diff -Naur drupal-7.43/modules/syslog/syslog.info drupal-7.50/modules/syslog/syslog.info
--- drupal-7.43/modules/syslog/syslog.info	2016-02-24 20:51:46.000000000 +0100
+++ drupal-7.50/modules/syslog/syslog.info	2016-07-07 21:08:13.000000000 +0200
@@ -6,8 +6,8 @@
 files[] = syslog.test
 configure = admin/config/development/logging
 
-; Information added by Drupal.org packaging script on 2016-02-24
-version = "7.43"
+; Information added by Drupal.org packaging script on 2016-07-07
+version = "7.50"
 project = "drupal"
-datestamp = "1456343506"
+datestamp = "1467918493"
 
diff -Naur drupal-7.43/modules/system/image.gd.inc drupal-7.50/modules/system/image.gd.inc
--- drupal-7.43/modules/system/image.gd.inc	2016-02-24 20:26:52.000000000 +0100
+++ drupal-7.50/modules/system/image.gd.inc	2016-07-07 20:25:52.000000000 +0200
@@ -116,38 +116,62 @@
     return FALSE;
   }
 
-  $width = $image->info['width'];
-  $height = $image->info['height'];
+  // PHP 5.5 GD bug: https://bugs.php.net/bug.php?id=65148: To prevent buggy
+  // behavior on negative multiples of 90 degrees we convert any negative
+  // angle to a positive one between 0 and 360 degrees.
+  $degrees -= floor($degrees / 360) * 360;
 
-  // Convert the hexadecimal background value to a color index value.
+  // Convert the hexadecimal background value to a RGBA array.
   if (isset($background)) {
-    $rgb = array();
-    for ($i = 16; $i >= 0; $i -= 8) {
-      $rgb[] = (($background >> $i) & 0xFF);
-    }
-    $background = imagecolorallocatealpha($image->resource, $rgb[0], $rgb[1], $rgb[2], 0);
+    $background = array(
+      'red' => $background >> 16 & 0xFF,
+      'green' => $background >> 8 & 0xFF,
+      'blue' => $background & 0xFF,
+      'alpha' => 0,
+    );
   }
-  // Set the background color as transparent if $background is NULL.
   else {
-    // Get the current transparent color.
-    $background = imagecolortransparent($image->resource);
-
-    // If no transparent colors, use white.
-    if ($background == 0) {
-      $background = imagecolorallocatealpha($image->resource, 255, 255, 255, 0);
-    }
+    // Background color is not specified: use transparent white as background.
+    $background = array(
+      'red' => 255,
+      'green' => 255,
+      'blue' => 255,
+      'alpha' => 127
+    );
   }
 
+  // Store the color index for the background as that is what GD uses.
+  $background_idx = imagecolorallocatealpha($image->resource, $background['red'], $background['green'], $background['blue'], $background['alpha']);
+
   // Images are assigned a new color palette when rotating, removing any
   // transparency flags. For GIF images, keep a record of the transparent color.
   if ($image->info['extension'] == 'gif') {
-    $transparent_index = imagecolortransparent($image->resource);
-    if ($transparent_index != 0) {
-      $transparent_gif_color = imagecolorsforindex($image->resource, $transparent_index);
+    // GIF does not work with a transparency channel, but can define 1 color
+    // in its palette to act as transparent.
+
+    // Get the current transparent color, if any.
+    $gif_transparent_id = imagecolortransparent($image->resource);
+    if ($gif_transparent_id !== -1) {
+      // The gif already has a transparent color set: remember it to set it on
+      // the rotated image as well.
+      $transparent_gif_color = imagecolorsforindex($image->resource, $gif_transparent_id);
+
+      if ($background['alpha'] >= 127) {
+        // We want a transparent background: use the color already set to act
+        // as transparent, as background.
+        $background_idx = $gif_transparent_id;
+      }
+    }
+    else {
+      // The gif does not currently have a transparent color set.
+      if ($background['alpha'] >= 127) {
+        // But as the background is transparent, it should get one.
+        $transparent_gif_color = $background;
+      }
     }
   }
 
-  $image->resource = imagerotate($image->resource, 360 - $degrees, $background);
+  $image->resource = imagerotate($image->resource, 360 - $degrees, $background_idx);
 
   // GIFs need to reassign the transparent color after performing the rotate.
   if (isset($transparent_gif_color)) {
diff -Naur drupal-7.43/modules/system/system.admin.inc drupal-7.50/modules/system/system.admin.inc
--- drupal-7.43/modules/system/system.admin.inc	2016-02-24 20:26:52.000000000 +0100
+++ drupal-7.50/modules/system/system.admin.inc	2016-07-07 20:25:52.000000000 +0200
@@ -1856,7 +1856,7 @@
   if (count($toolkits_available) == 0) {
     variable_del('image_toolkit');
     $form['image_toolkit_help'] = array(
-      '#markup' => t("No image toolkits were detected. Drupal includes support for <a href='!gd-link'>PHP's built-in image processing functions</a> but they were not detected on this system. You should consult your system administrator to have them enabled, or try using a third party toolkit.", array('gd-link' => url('http://php.net/gd'))),
+      '#markup' => t("No image toolkits were detected. Drupal includes support for <a href='!gd-link'>PHP's built-in image processing functions</a> but they were not detected on this system. You should consult your system administrator to have them enabled, or try using a third party toolkit.", array('!gd-link' => url('http://php.net/gd'))),
     );
     return $form;
   }
diff -Naur drupal-7.43/modules/system/system.api.php drupal-7.50/modules/system/system.api.php
--- drupal-7.43/modules/system/system.api.php	2016-02-24 20:26:52.000000000 +0100
+++ drupal-7.50/modules/system/system.api.php	2016-07-07 20:25:52.000000000 +0200
@@ -1797,6 +1797,8 @@
  * the $form_id input matched your module's format for dynamically-generated
  * form IDs, and if so, act appropriately.
  *
+ * Third, forms defined in classes can be defined this way.
+ *
  * @param $form_id
  *   The unique string identifying the desired form.
  * @param $args
@@ -1807,19 +1809,22 @@
  * @return
  *   An associative array whose keys define form_ids and whose values are an
  *   associative array defining the following keys:
- *   - callback: The name of the form builder function to invoke. This will be
- *     used for the base form ID, for example, to target a base form using
- *     hook_form_BASE_FORM_ID_alter().
+ *   - callback: The callable returning the form array. If it is the name of
+ *     the form builder function then this will be used for the base
+ *     form ID, for example, to target a base form using
+ *     hook_form_BASE_FORM_ID_alter(). Otherwise use the base_form_id key to
+ *     define the base form ID.
  *   - callback arguments: (optional) Additional arguments to pass to the
  *     function defined in 'callback', which are prepended to $args.
- *   - wrapper_callback: (optional) The name of a form builder function to
- *     invoke before the form builder defined in 'callback' is invoked. This
- *     wrapper callback may prepopulate the $form array with form elements,
- *     which will then be already contained in the $form that is passed on to
- *     the form builder defined in 'callback'. For example, a wrapper callback
- *     could setup wizard-alike form buttons that are the same for a variety of
- *     forms that belong to the wizard, which all share the same wrapper
- *     callback.
+ *   - base_form_id: The base form ID can be specified explicitly. This is
+ *     required when callback is not the name of a function.
+ *   - wrapper_callback: (optional) Any callable to invoke before the form
+ *     builder defined in 'callback' is invoked. This wrapper callback may
+ *     prepopulate the $form array with form elements, which will then be
+ *     already contained in the $form that is passed on to the form builder
+ *     defined in 'callback'. For example, a wrapper callback could setup
+ *     wizard-like form buttons that are the same for a variety of forms that
+ *     belong to the wizard, which all share the same wrapper callback.
  */
 function hook_forms($form_id, $args) {
   // Simply reroute the (non-existing) $form_id 'mymodule_first_form' to
@@ -1843,6 +1848,15 @@
     'wrapper_callback' => 'mymodule_main_form_wrapper',
   );
 
+  // Build a form with a static class callback.
+  $forms['mymodule_class_generated_form'] = array(
+    // This will call: MyClass::generateMainForm().
+    'callback' => array('MyClass', 'generateMainForm'),
+    // The base_form_id is required when the callback is a static function in
+    // a class. This can also be used to keep newer code backwards compatible.
+    'base_form_id' => 'mymodule_main_form',
+  );
+
   return $forms;
 }
 
diff -Naur drupal-7.43/modules/system/system.info drupal-7.50/modules/system/system.info
--- drupal-7.43/modules/system/system.info	2016-02-24 20:51:46.000000000 +0100
+++ drupal-7.50/modules/system/system.info	2016-07-07 21:08:13.000000000 +0200
@@ -12,8 +12,8 @@
 required = TRUE
 configure = admin/config/system
 
-; Information added by Drupal.org packaging script on 2016-02-24
-version = "7.43"
+; Information added by Drupal.org packaging script on 2016-07-07
+version = "7.50"
 project = "drupal"
-datestamp = "1456343506"
+datestamp = "1467918493"
 
diff -Naur drupal-7.43/modules/system/system.install drupal-7.50/modules/system/system.install
--- drupal-7.43/modules/system/system.install	2016-02-24 20:26:52.000000000 +0100
+++ drupal-7.50/modules/system/system.install	2016-07-07 20:25:52.000000000 +0200
@@ -196,6 +196,12 @@
     );
   }
 
+  // Test database-specific multi-byte UTF-8 related requirements.
+  $charset_requirements = _system_check_db_utf8mb4_requirements($phase);
+  if (!empty($charset_requirements)) {
+    $requirements['database_charset'] = $charset_requirements;
+  }
+
   // Test PHP memory_limit
   $memory_limit = ini_get('memory_limit');
   $requirements['php_memory_limit'] = array(
@@ -518,6 +524,75 @@
 }
 
 /**
+ * Checks whether the requirements for multi-byte UTF-8 support are met.
+ *
+ * @param string $phase
+ *   The hook_requirements() stage.
+ *
+ * @return array
+ *   A requirements array with the result of the charset check.
+ */
+function _system_check_db_utf8mb4_requirements($phase) {
+  global $install_state;
+  // In the requirements check of the installer, skip the utf8mb4 check unless
+  // the database connection info has been preconfigured by hand with valid
+  // information before running the installer, as otherwise we cannot get a
+  // valid database connection object.
+  if (isset($install_state['settings_verified']) && !$install_state['settings_verified']) {
+    return array();
+  }
+
+  $connection = Database::getConnection();
+  $t = get_t();
+  $requirements['title'] = $t('Database 4 byte UTF-8 support');
+
+  $utf8mb4_configurable = $connection->utf8mb4IsConfigurable();
+  $utf8mb4_active = $connection->utf8mb4IsActive();
+  $utf8mb4_supported = $connection->utf8mb4IsSupported();
+  $driver = $connection->driver();
+  $documentation_url = 'https://www.drupal.org/node/2754539';
+
+  if ($utf8mb4_active) {
+    if ($utf8mb4_supported) {
+      if ($phase != 'install' && $utf8mb4_configurable && !variable_get('drupal_all_databases_are_utf8mb4', FALSE)) {
+        // Supported, active, and configurable, but not all database tables
+        // have been converted yet.
+        $requirements['value'] = $t('Enabled, but database tables need conversion');
+        $requirements['description'] = $t('Please convert all database tables to utf8mb4 prior to enabling it in settings.php. See the <a href="@url">documentation on adding 4 byte UTF-8 support</a> for more information.', array('@url' => $documentation_url));
+        $requirements['severity'] = REQUIREMENT_ERROR;
+      }
+      else {
+        // Supported, active.
+        $requirements['value'] = $t('Enabled');
+        $requirements['description'] = $t('4 byte UTF-8 for @driver is enabled.', array('@driver' => $driver));
+        $requirements['severity'] = REQUIREMENT_OK;
+      }
+    }
+    else {
+      // Not supported, active.
+      $requirements['value'] = $t('Not supported');
+      $requirements['description'] = $t('4 byte UTF-8 for @driver is activated, but not supported on your system. Please turn this off in settings.php, or ensure that all database-related requirements are met. See the <a href="@url">documentation on adding 4 byte UTF-8 support</a> for more information.', array('@driver' => $driver, '@url' => $documentation_url));
+      $requirements['severity'] = REQUIREMENT_ERROR;
+    }
+  }
+  else {
+    if ($utf8mb4_supported) {
+      // Supported, not active.
+      $requirements['value'] = $t('Not enabled');
+      $requirements['description'] = $t('4 byte UTF-8 for @driver is not activated, but it is supported on your system. It is recommended that you enable this to allow 4-byte UTF-8 input such as emojis, Asian symbols and mathematical symbols to be stored correctly. See the <a href="@url">documentation on adding 4 byte UTF-8 support</a> for more information.', array('@driver' => $driver, '@url' => $documentation_url));
+      $requirements['severity'] = REQUIREMENT_INFO;
+    }
+    else {
+      // Not supported, not active.
+      $requirements['value'] = $t('Disabled');
+      $requirements['description'] = $t('4 byte UTF-8 for @driver is disabled. See the <a href="@url">documentation on adding 4 byte UTF-8 support</a> for more information.', array('@driver' => $driver, '@url' => $documentation_url));
+      $requirements['severity'] = REQUIREMENT_INFO;
+    }
+  }
+  return $requirements;
+}
+
+/**
  * Implements hook_install().
  */
 function system_install() {
@@ -532,6 +607,9 @@
   module_list(TRUE);
   module_implements('', FALSE, TRUE);
 
+  // Ensure the schema versions are not based on a previous module list.
+  drupal_static_reset('drupal_get_schema_versions');
+
   // Load system theme data appropriately.
   system_rebuild_theme_data();
 
diff -Naur drupal-7.43/modules/system/system.module drupal-7.50/modules/system/system.module
--- drupal-7.43/modules/system/system.module	2016-02-24 20:26:52.000000000 +0100
+++ drupal-7.50/modules/system/system.module	2016-07-07 20:25:52.000000000 +0200
@@ -3317,7 +3317,7 @@
   $form['url'] = array(
     '#type' => 'textfield',
     '#title' => t('URL'),
-    '#description' => t('The URL to which the user should be redirected. This can be an internal URL like node/1234 or an external URL like http://drupal.org.'),
+    '#description' => t('The URL to which the user should be redirected. This can be an internal path like node/1234 or an external URL like http://example.com.'),
     '#default_value' => isset($context['url']) ? $context['url'] : '',
     '#required' => TRUE,
   );
diff -Naur drupal-7.43/modules/system/system.queue.inc drupal-7.50/modules/system/system.queue.inc
--- drupal-7.43/modules/system/system.queue.inc	2016-02-24 20:26:52.000000000 +0100
+++ drupal-7.50/modules/system/system.queue.inc	2016-07-07 20:25:52.000000000 +0200
@@ -326,6 +326,7 @@
     $item->created = time();
     $item->expire = 0;
     $this->queue[$item->item_id] = $item;
+    return TRUE;
   }
 
   public function numberOfItems() {
diff -Naur drupal-7.43/modules/system/system.test drupal-7.50/modules/system/system.test
--- drupal-7.43/modules/system/system.test	2016-02-24 20:26:52.000000000 +0100
+++ drupal-7.50/modules/system/system.test	2016-07-07 20:25:52.000000000 +0200
@@ -2355,6 +2355,20 @@
   }
 
   /**
+   * Tests that there are no pending updates for the first test method.
+   */
+  function testNoPendingUpdates() {
+    // Ensure that for the first test method in a class, there are no pending
+    // updates. This tests a drupal_get_schema_versions() bug that previously
+    // led to the wrong schema version being recorded for the initial install
+    // of a child site during automated testing.
+    $this->drupalLogin($this->update_user);
+    $this->drupalGet($this->update_url, array('external' => TRUE));
+    $this->drupalPost(NULL, array(), t('Continue'));
+    $this->assertText(t('No pending updates.'), 'End of update process was reached.');
+  }
+
+  /**
    * Tests access to the update script.
    */
   function testUpdateAccess() {
diff -Naur drupal-7.43/modules/system/system.updater.inc drupal-7.50/modules/system/system.updater.inc
--- drupal-7.43/modules/system/system.updater.inc	2016-02-24 20:26:52.000000000 +0100
+++ drupal-7.50/modules/system/system.updater.inc	2016-07-07 20:25:52.000000000 +0200
@@ -24,7 +24,7 @@
    * found on your system, and if there was a copy in sites/all, we'd see it.
    */
   public function getInstallDirectory() {
-    if ($relative_path = drupal_get_path('module', $this->name)) {
+    if ($this->isInstalled() && ($relative_path = drupal_get_path('module', $this->name))) {
       $relative_path = dirname($relative_path);
     }
     else {
@@ -34,7 +34,7 @@
   }
 
   public function isInstalled() {
-    return (bool) drupal_get_path('module', $this->name);
+    return (bool) drupal_get_filename('module', $this->name, NULL, FALSE);
   }
 
   public static function canUpdateDirectory($directory) {
@@ -109,7 +109,7 @@
    * found on your system, and if there was a copy in sites/all, we'd see it.
    */
   public function getInstallDirectory() {
-    if ($relative_path = drupal_get_path('theme', $this->name)) {
+    if ($this->isInstalled() && ($relative_path = drupal_get_path('theme', $this->name))) {
       $relative_path = dirname($relative_path);
     }
     else {
@@ -119,7 +119,7 @@
   }
 
   public function isInstalled() {
-    return (bool) drupal_get_path('theme', $this->name);
+    return (bool) drupal_get_filename('theme', $this->name, NULL, FALSE);
   }
 
   static function canUpdateDirectory($directory) {
diff -Naur drupal-7.43/modules/system/tests/cron_queue_test.info drupal-7.50/modules/system/tests/cron_queue_test.info
--- drupal-7.43/modules/system/tests/cron_queue_test.info	2016-02-24 20:51:46.000000000 +0100
+++ drupal-7.50/modules/system/tests/cron_queue_test.info	2016-07-07 21:08:13.000000000 +0200
@@ -5,8 +5,8 @@
 core = 7.x
 hidden = TRUE
 
-; Information added by Drupal.org packaging script on 2016-02-24
-version = "7.43"
+; Information added by Drupal.org packaging script on 2016-07-07
+version = "7.50"
 project = "drupal"
-datestamp = "1456343506"
+datestamp = "1467918493"
 
diff -Naur drupal-7.43/modules/system/tests/system_cron_test.info drupal-7.50/modules/system/tests/system_cron_test.info
--- drupal-7.43/modules/system/tests/system_cron_test.info	2016-02-24 20:51:46.000000000 +0100
+++ drupal-7.50/modules/system/tests/system_cron_test.info	2016-07-07 21:08:13.000000000 +0200
@@ -5,8 +5,8 @@
 core = 7.x
 hidden = TRUE
 
-; Information added by Drupal.org packaging script on 2016-02-24
-version = "7.43"
+; Information added by Drupal.org packaging script on 2016-07-07
+version = "7.50"
 project = "drupal"
-datestamp = "1456343506"
+datestamp = "1467918493"
 
diff -Naur drupal-7.43/modules/taxonomy/taxonomy.info drupal-7.50/modules/taxonomy/taxonomy.info
--- drupal-7.43/modules/taxonomy/taxonomy.info	2016-02-24 20:51:46.000000000 +0100
+++ drupal-7.50/modules/taxonomy/taxonomy.info	2016-07-07 21:08:13.000000000 +0200
@@ -8,8 +8,8 @@
 files[] = taxonomy.test
 configure = admin/structure/taxonomy
 
-; Information added by Drupal.org packaging script on 2016-02-24
-version = "7.43"
+; Information added by Drupal.org packaging script on 2016-07-07
+version = "7.50"
 project = "drupal"
-datestamp = "1456343506"
+datestamp = "1467918493"
 
diff -Naur drupal-7.43/modules/taxonomy/taxonomy.install drupal-7.50/modules/taxonomy/taxonomy.install
--- drupal-7.43/modules/taxonomy/taxonomy.install	2016-02-24 20:26:52.000000000 +0100
+++ drupal-7.50/modules/taxonomy/taxonomy.install	2016-07-07 20:25:52.000000000 +0200
@@ -492,6 +492,7 @@
       'bundle' => $bundle->type,
       'settings' => array(),
       'description' => 'Debris left over after upgrade from Drupal 6',
+      'required' => FALSE,
       'widget' => array(
         'type' => 'taxonomy_autocomplete',
         'module' => 'taxonomy',
@@ -557,7 +558,7 @@
   // of term references stored so far for the current revision, which
   // provides the delta value for each term reference data insert. The
   // deltas are reset for each new revision.
-  
+
   $conditions = array(
     'type' => 'taxonomy_term_reference',
     'deleted' => 0,
diff -Naur drupal-7.43/modules/taxonomy/taxonomy.test drupal-7.50/modules/taxonomy/taxonomy.test
--- drupal-7.43/modules/taxonomy/taxonomy.test	2016-02-24 20:26:52.000000000 +0100
+++ drupal-7.50/modules/taxonomy/taxonomy.test	2016-07-07 20:25:52.000000000 +0200
@@ -1025,7 +1025,7 @@
 
   function setUp() {
     parent::setUp('taxonomy');
-    $this->admin_user = $this->drupalCreateUser(array('administer taxonomy', 'bypass node access', 'administer content types'));
+    $this->admin_user = $this->drupalCreateUser(array('administer taxonomy', 'bypass node access', 'administer content types', 'administer fields'));
     $this->drupalLogin($this->admin_user);
     $this->vocabulary = $this->createVocabulary();
 
diff -Naur drupal-7.43/modules/toolbar/toolbar.info drupal-7.50/modules/toolbar/toolbar.info
--- drupal-7.43/modules/toolbar/toolbar.info	2016-02-24 20:51:46.000000000 +0100
+++ drupal-7.50/modules/toolbar/toolbar.info	2016-07-07 21:08:13.000000000 +0200
@@ -4,8 +4,8 @@
 package = Core
 version = VERSION
 
-; Information added by Drupal.org packaging script on 2016-02-24
-version = "7.43"
+; Information added by Drupal.org packaging script on 2016-07-07
+version = "7.50"
 project = "drupal"
-datestamp = "1456343506"
+datestamp = "1467918493"
 
